using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Reflection;
using ObjectLibrary;

namespace ObjectViewer
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
    private System.Windows.Forms.TextBox teamName;
    private System.Windows.Forms.Button button1;
    private System.Windows.Forms.Button button2;
    private System.Windows.Forms.Label primaryLabel;
    private System.Windows.Forms.Label secondaryLabel;
    private System.Windows.Forms.Label tertiaryLabel;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.teamName = new System.Windows.Forms.TextBox();
      this.button1 = new System.Windows.Forms.Button();
      this.primaryLabel = new System.Windows.Forms.Label();
      this.button2 = new System.Windows.Forms.Button();
      this.secondaryLabel = new System.Windows.Forms.Label();
      this.tertiaryLabel = new System.Windows.Forms.Label();
      this.SuspendLayout();
      // 
      // teamName
      // 
      this.teamName.Location = new System.Drawing.Point(8, 8);
      this.teamName.Name = "teamName";
      this.teamName.Size = new System.Drawing.Size(248, 20);
      this.teamName.TabIndex = 0;
      this.teamName.Text = "";
      // 
      // button1
      // 
      this.button1.Location = new System.Drawing.Point(264, 8);
      this.button1.Name = "button1";
      this.button1.Size = new System.Drawing.Size(112, 23);
      this.button1.TabIndex = 1;
      this.button1.Text = "Get Team Name";
      this.button1.Click += new System.EventHandler(this.button1_Click);
      // 
      // primaryLabel
      // 
      this.primaryLabel.Location = new System.Drawing.Point(8, 40);
      this.primaryLabel.Name = "primaryLabel";
      this.primaryLabel.Size = new System.Drawing.Size(72, 23);
      this.primaryLabel.TabIndex = 2;
      this.primaryLabel.Text = "Primary:";
      // 
      // button2
      // 
      this.button2.Location = new System.Drawing.Point(264, 40);
      this.button2.Name = "button2";
      this.button2.Size = new System.Drawing.Size(112, 23);
      this.button2.TabIndex = 3;
      this.button2.Text = "Get Class Attributes";
      this.button2.Click += new System.EventHandler(this.button2_Click);
      // 
      // secondaryLabel
      // 
      this.secondaryLabel.Location = new System.Drawing.Point(96, 40);
      this.secondaryLabel.Name = "secondaryLabel";
      this.secondaryLabel.Size = new System.Drawing.Size(72, 23);
      this.secondaryLabel.TabIndex = 4;
      this.secondaryLabel.Text = "Secondary:";
      // 
      // tertiaryLabel
      // 
      this.tertiaryLabel.Location = new System.Drawing.Point(184, 40);
      this.tertiaryLabel.Name = "tertiaryLabel";
      this.tertiaryLabel.Size = new System.Drawing.Size(72, 24);
      this.tertiaryLabel.TabIndex = 5;
      this.tertiaryLabel.Text = "Tertiary:";
      // 
      // Form1
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(384, 86);
      this.Controls.Add(this.tertiaryLabel);
      this.Controls.Add(this.secondaryLabel);
      this.Controls.Add(this.button2);
      this.Controls.Add(this.primaryLabel);
      this.Controls.Add(this.button1);
      this.Controls.Add(this.teamName);
      this.Name = "Form1";
      this.Text = "Form1";
      this.ResumeLayout(false);

    }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

    private void button1_Click(object sender, System.EventArgs e)
    {
      Assembly assembly = Assembly.GetAssembly(typeof(AssemblyTeamAttribute));
      object[] attrs = assembly.GetCustomAttributes(false);
      foreach (object attr in attrs)
      {
        if (attr is AssemblyTeamAttribute)
        {
          AssemblyTeamAttribute team = (AssemblyTeamAttribute)attr;
          teamName.Text = team.TeamName;
        }
      }
    }

    private void button2_Click(object sender, System.EventArgs e)
    {
      // Create the Instances of the BaseClass
      BaseClass[] bases = new BaseClass[10];
      bases[0] = new FirstClass();
      bases[1] = new SecondClass();
      bases[2] = new JustAnotherClass();
      bases[3] = new YetAnotherClass();
      bases[4] = new FirstClass();
      bases[5] = new SecondClass();
      bases[6] = new JustAnotherClass();
      bases[7] = new YetAnotherClass();
      bases[8] = new FirstClass();
      bases[9] = new SecondClass();

      // Initialize Counters
      int first = 0;
      int second = 0;
      int tertiary = 0;

      // Go through each of the items in the array
      foreach (BaseClass item in bases)
      {
        // Retrieve the appropriate attribute
        Attribute attr = Attribute.GetCustomAttribute(item.GetType(), 
          typeof(OrderingPriorityAttribute));

        // If the attribute is found
        if (attr != null)
        {
          OrderingPriorityAttribute order = (OrderingPriorityAttribute) attr;

          // Test the Priority of the attribute and 
          // update the counters
          if (order.Priority == Priority.Primary) first++;
          if (order.Priority == Priority.Secondary) second++;
          if (order.Priority == Priority.Tertiary) tertiary++;
        }
      }

      // Show the counter results
      primaryLabel.Text = string.Format("Primary: {0}", first);
      secondaryLabel.Text = string.Format("Secondary: {0}", second);
      tertiaryLabel.Text = string.Format("Tertiary: {0}", tertiary);
    }
	}

  [Serializable]
  public class MySpecialClass
  {
    // Serializable since the class is
    // marked with the Serializable attribute
    public string dataOne;
    public string dataTwo;
    public string dataThree;
    public string dataFour;

    // Not serializable since we marked it
    [NonSerialized]
    public string dataFive;

  }
}
